#import "Convert.h"
#import "NavigineHelper.h"

@implementation NavigineHelper : NSObject

NavigineCore *navigineCore;
FlutterMethodChannel *methodChannel;

- (NavigineHelper*) initWithMethodChannel:(FlutterMethodChannel*)channel {
    methodChannel = channel;
    return self;
}

- (void) initilizeSDK:(NSString*)userHash serverURL:(NSString*)serverURL{
    navigineCore = [[NavigineCore alloc] initWithUserHash:userHash];
}

-(void) loadLocation:(NSNumber*)locationId {
    NSInteger locationIdInteger = [locationId integerValue];
    [navigineCore downloadLocationById:locationIdInteger forceReload:NO  processBlock:^(NSInteger loadProcess) {
        NSNumber *val = [NSNumber numberWithInteger:loadProcess];
        [methodChannel invokeMethod:@"location#onUpdate" arguments:val];
    } successBlock:^(NSDictionary *userInfo) {
        [methodChannel invokeMethod:@"location#onFinished" arguments:nil];
    } failBlock:^(NSError *error) {
        NSNumber *val = [NSNumber numberWithInteger:[error code]];
        [methodChannel invokeMethod:@"location#onFailed" arguments:val];
    }];
}

-(void) startNavigation {
    [navigineCore startNavigine];
}

-(void) stopNavigation {
    [navigineCore stopNavigine];
}

-(id) getLocation {
    return [Convert locationInfoToObject: [navigineCore location]];
}

-(id) getDeviceInfo {
    return [Convert deviceInfoToObject:[navigineCore deviceInfo]];
}

@end
