#import "NaviginePlugin.h"
#import "NavigineHelper.h"

@implementation NaviginePlugin 

NavigineHelper *navigineHelper;

+ (void)registerWithRegistrar:(NSObject<FlutterPluginRegistrar>*)registrar {
  FlutterMethodChannel* channel = [FlutterMethodChannel
      methodChannelWithName:@"navigine"
            binaryMessenger:[registrar messenger]];
  NaviginePlugin* instance = [[NaviginePlugin alloc] init];
  navigineHelper = [[NavigineHelper alloc]  initWithMethodChannel:channel];
  [registrar addMethodCallDelegate:instance channel:channel];
}

- (void)handleMethodCall:(FlutterMethodCall*)call result:(FlutterResult)result {
  if ([@"initialize" isEqualToString:call.method]) {
      NSString* userHash = call.arguments[@"userHash"];
      NSString* serverUrl = call.arguments[@"serverUrl"];
      [navigineHelper initilizeSDK:userHash serverURL:serverUrl];
      result(@TRUE);
  } else if ([@"loadLocation" isEqualToString:call.method]) {
      NSNumber* locationId = call.arguments[@"locationId"];
      [navigineHelper loadLocation:locationId];
      result(@TRUE);
  } else if([@"startNavigation" isEqualToString:call.method]){
      [navigineHelper startNavigation];
      result(@TRUE);
  } else if([@"stopNavigation" isEqualToString:call.method]){
      [navigineHelper stopNavigation];
      result(@TRUE);
  } else if([@"getLocation" isEqualToString:call.method]){
      result([navigineHelper getLocation]);
  } else if([@"getDeviceInfo" isEqualToString:call.method]){
      result([navigineHelper getDeviceInfo]);
  } else if([@"getDeviceInfoStream" isEqualToString:call.method]){
      // TODO add a serializer and probably listen to stream every some seconds
      // [navigineHelper stopNavigation];
  } else {
      result(FlutterMethodNotImplemented);
  }
}

@end
