part of navigine_sdk;

class NavigationThread {
  StreamController<DeviceInfo> controller;

  static Future<NavigationThread> startNavigation({
    NavigationMode mode = NavigationMode.MODE_NORMAL,
  }) async {
    await _channel.invokeMethod("startNavigation", {
      "mode": _getModeCode(mode),
    });
    return NavigationThread();
  }

  stopNavigation() async {
    await _channel.invokeMethod("stopNavigation");
  }

  Future<Location> getLocation() async {
    return Location.fromMap(await _channel.invokeMethod("getLocation"));
  }

  Stream<DeviceInfo> getDeviceInfoListener() {
    _channel.invokeMethod("getDeviceInfoStream", null);
    controller = StreamController<DeviceInfo>();
    _channel.setMethodCallHandler((call) async {
      switch (call.method) {
        case "deviceInfo#onUpdate":
          controller.add(DeviceInfo.fromMap(call.arguments));
          break;
        default:
      }
    });
    controller.onCancel = () {
      controller.close();
    };
    return controller.stream;
  }

  Future<DeviceInfo> getDeviceInfo() async {
    return DeviceInfo.fromMap(await _channel.invokeMethod("getDeviceInfo"));
  }

  static _getModeCode(NavigationMode mode) {
    switch (mode) {
      case NavigationMode.MODE_IDLE:
        return 1;
      case NavigationMode.MODE_SCAN:
        return 2;
      case NavigationMode.MODE_NORMAL:
        return 3;
      case NavigationMode.MODE_ECONOMIC:
        return 4;
      default:
    }
  }
}

enum NavigationMode {
  MODE_IDLE,
  MODE_SCAN,
  MODE_NORMAL,
  MODE_ECONOMIC,
}
